searchNodes=[{"doc":"Sends a test event to Sentry to check if your Sentry configuration is correct. This task reports a RuntimeError exception like this one: % RuntimeError { message : &quot;Testing sending Sentry event&quot; } Options --no-compile - does not compile, even if files require compilation.","ref":"Mix.Tasks.Sentry.SendTestEvent.html","title":"Mix.Tasks.Sentry.SendTestEvent","type":"task"},{"doc":"Provides the functionality to submit events to Sentry . This library can be used to submit events to Sentry from any Elixir application. It supports several ways of reporting events: Manually — see capture_exception/2 and capture_message/2 . Through an Elixir Logger backend — see Sentry.LoggerBackend . Automatically for Plug/Phoenix applications — see the Setup with Plug and Phoenix guide , and the Sentry.PlugCapture and Sentry.PlugContext modules. Usage Add the following to your production configuration: # In config/prod.exs config :sentry , dsn : &quot;https://public:secret@app.getsentry.com/1&quot; , included_environments : [ :prod ] , environment_name : :prod , tags : %{ env : &quot;production&quot; } The :environment_name and :included_environments options work together to determine if and when Sentry should record exceptions. The :environment_name is the name of the current environment. In the example above, we have explicitly set the environment to :prod which works well if you are inside an environment specific configuration config/prod.exs . An alternative is to use Config.config_env/0 in your general config/config.exs configuration file: config :sentry , dsn : &quot;https://public:secret@app.getsentry.com/1&quot; , included_environments : [ :prod ] , environment_name : config_env ( ) This will set the environment name to whatever the current environment is, but it will only send events if the current environment is :prod , since that is the only entry in the :included_environments key. You can even rely on more specific logic to determine the environment name. It's not uncommon for most applications to have a &quot;staging&quot; environment. In order to handle this without adding an additional Mix environment, you can set an environment variable that determines the release level. By default, Sentry picks up the SENTRY_ENVIRONMENT variable. Otherwise, you can read the variable at runtime. Do this only in config/runtime.exs so that it will work both for local development as well as Mix releases. # In config/runtime.exs config :sentry , dsn : &quot;https://public:secret@app.getsentry.com/1&quot; , included_environments : [ &quot;production&quot; , &quot;staging&quot; ] , environment_name : System . get_env ( &quot;RELEASE_LEVEL&quot; , &quot;development&quot; ) In this example, we are getting the environment name from the RELEASE_LEVEL environment variable. If that variable does not exist, we default to &quot;development&quot; . Now, on our servers, we can set the environment variable appropriately. On our local development machines, exceptions will never be sent, because the default value is not in the list of :included_environments . Using the DSN To Send Events We recommend to use the :dsn configuration to control whether to report events. If :dsn is not set (or set to nil ), then we won't report events to Sentry. Thanks to this behavior, you can essentially only set :dsn in environments where you want to report events to Sentry. In the future, we might remove the :included_environments configuration altogether. Sentry supports many configuration options. See the Configuration section for complete documentation. Configuration You can configure Sentry through the application environment. Configure the following keys under the :sentry application. For example, you can do this in config/config.exs : # config/config.exs config :sentry , # ... The basic configuration options are: :dsn ( String.t/0 ) - the DSN for your Sentry project. If this is not set, Sentry will not be enabled. If the SENTRY_DSN environment variable is set, it will be used as the default value. :release ( String.t/0 ) - the release version of your application. This is used to correlate events with source code. If the SENTRY_RELEASE environment variable is set, it will be used as the default value. :environment_name ( atom/0 or String.t/0 ) - the current environment name. This is used to determine if Sentry should be enabled and if events should be sent. For events to be sent, the value of this option must appear in the :included_environments list. If the SENTRY_ENVIRONMENT environment variable is set, it will be used as the defaults value. Otherwise, defaults to &quot;dev&quot; . :included_environments (list of atom/0 or String.t/0 , or the atom :all ) - the environments in which Sentry can report events. If this is a list, then :environment_name needs to be in this list for events to be reported. If this is :all , then Sentry will report events regardless of the value of :environment_name . Defaults to :all . :tags ( map/0 ) - a map of tags to be sent with every event. Defaults to %{} . :server_name ( String.t/0 ) - the name of the server running the application. Not used by default. :filter ( module/0 ) - a module that implements the Sentry.Filter behaviour. Defaults to Sentry.DefaultEventFilter . See the Filtering Exceptions section below. :json_library ( module/0 ) - a module that implements the &quot;standard&quot; Elixir JSON behaviour, that is, exports the encode/1 and decode/1 functions. Defaults to Jason , which requires :jason to be a dependency of your application. :log_level ( Logger.level/0 ) - the level to use when Sentry fails to send an event due to an API failure or other reasons. Defaults to :warning . To customize what happens when sending an event, you can use these options: :sample_rate ( float/0 between 0.0 and 1.0 ) - the percentage of events to send to Sentry. Defaults to 1.0 (100% of events). :send_result ( atom/0 ) - controls what to return when reporting exceptions to Sentry. Defaults to :none . :send_max_attempts ( integer/0 ) - the maximum number of attempts to send an event to Sentry. Defaults to 4 . :max_breadcrumbs ( integer/0 ) - the maximum number of breadcrumbs to keep. Defaults to 100 . See Sentry.Context.add_breadcrumb/1 . :before_send_event ( before_send_event_callback/0 ) - allows performing operations on the event before it is sent as well as filtering out the event altogether. If the callback returns nil or false , the event is not reported. If it returns an updated Sentry.Event , then the updated event is used instead. See the Event Callbacks section below for more information. :after_send_event ( after_send_event_callback/0 ) - callback that is called after attempting to send an event. The result of the HTTP call as well as the event will be passed as arguments. The return value of the callback is not returned. See the Event Callbacks section below for more information. :in_app_module_allow_list (list of module/0 ) - a list of modules that is used to distinguish among stacktrace frames that belong to your app and ones that are part of libraries or core Elixir. This is used to better display the significant part of stacktraces. The logic is &quot;greedy&quot;, so if your app's root module is MyApp and you configure this option to [MyApp] , MyApp as well as any submodules (like MyApp.Submodule ) would be considered part of your app. Defaults to [] . To customize the behaviour of the HTTP client used by Sentry, you can use these options: :client ( module/0 ) - a module that implements the Sentry.HTTPClient behaviour. Defaults to Sentry.HackneyClient , which uses hackney as the HTTP client. :hackney_opts ( keyword/0 ) - options to be passed to hackney . Only applied if :client is set to Sentry.HackneyClient . Defaults to [pool: :sentry_pool] . :hackney_pool_max_connections ( integer/0 ) - the maximum number of connections to keep in the pool. Only applied if :client is set to Sentry.HackneyClient . Defaults to 50 . :hackney_pool_timeout ( integer/0 ) - the maximum time to wait for a connection to become available. Only applied if :client is set to Sentry.HackneyClient . Defaults to 5000 . To customize options related to reporting source code context, you can use these options: :report_deps ( boolean/0 ) - whether to report Mix dependencies of your application alongside events. If true , this attempts to load dependencies at compile time . Defaults to true . :enable_source_code_context ( boolean/0 ) - whether to report source code context alongside events. Defaults to false . :root_source_code_paths (list of Path.t/0 ) - a list of paths to the root of your application's source code. This is used to determine the relative path of files in stack traces. Usually, you'll want to set this to [File.cwd!()] . For umbrella apps, you should set this to all the application paths in your umbrella (such as [Path.join(File.cwd!(), &quot;apps/app1&quot;), ...] ). Required if :enabled_source_code_context is true . :source_code_path_pattern ( String.t/0 ) - a glob pattern used to determine which files to report source code context for. The glon &quot;starts&quot; from :root_source_code_paths . Defaults to &quot;**/*.ex&quot; . :source_code_exclude_patterns (list of Regex.t/0 ) - a list of regular expressions used to determine which files to exclude from source code context. Defaults to [~r&quot;/_build/&quot;, ~r&quot;/deps/&quot;, ~r&quot;/priv/&quot;] . :context_lines ( integer/0 ) - the number of lines of source code before and after the line that caused the exception to report. Defaults to 3 . Compile-time Configuration These options are only available at compile-time: :enable_source_code_context :root_source_code_paths :report_deps :source_code_path_pattern :source_code_exclude_patterns If you change the value of any of these, you'll need to recompile Sentry itself. You can run mix deps.compile sentry to do that. Configuration Through System Environment Sentry supports loading configuration from the system environment. You can do this by setting SENTRY_&lt;name&gt; environment variables. For example, to set the :release option through the system environment, you can set the SENTRY_RELEASE environment variable. The supported SENTRY_&lt;name&gt; environment variables are: SENTRY_RELEASE SENTRY_ENVIRONMENT SENTRY_DSN Filtering Exceptions If you would like to prevent Sentry from sending certain exceptions, you can use the :before_send_event configuration option. See the Event Callbacks section below. Before v9.0.0, the recommended way to filter out exceptions was to use a filter , that is, a module implementing the Sentry.EventFilter behaviour. This is still supported, but is not deprecated. See Sentry.EventFilter for more information. Event Callbacks You can configure the :before_send_event and :after_send_event options to customize what happens before and/or after sending an event. The :before_send_event callback must be of type before_send_event_callback/0 and the :after_send_event callback must be of type after_send_event_callback/0 . For example, you can set: config :sentry , before_send_event : { MyModule , :before_send } , after_send_event : { MyModule , :after_send } MyModule could look like this: defmodule MyModule do def before_send ( event ) do metadata = Map . new ( Logger . metadata ( ) ) % Sentry.Event { event | extra : Map . merge ( event . extra , metadata ) } end def after_send_event ( event , result ) do case result do { :ok , id } -&gt; Logger . info ( &quot;Successfully sent event!&quot; ) { :error , _reason } -&gt; Logger . info ( fn -&gt; &quot;Did not successfully send event! \#{ inspect ( event ) } &quot; end ) end end end Reporting Source Code Sentry supports reporting the source code of (and around) the line that caused an issue. To support this functionality, this library stores the text of source files during compilation. An example configuration to enable this functionality is: config :sentry , dsn : &quot;https://public:secret@app.getsentry.com/1&quot; , enable_source_code_context : true , root_source_code_paths : [ File . cwd! ( ) ] , context_lines : 5 File contents are saved when Sentry is compiled, which can cause some complications. If a file is changed, and Sentry is not recompiled, it will still report old source code. The best way to ensure source code is up to date is to recompile Sentry itself via mix deps.compile sentry --force . It's possible to create a Mix task alias in mix.exs to do this. The example below would allow you to run mix sentry_recompile &amp;&amp; mix compile which will force recompilation of Sentry so it has the newest source and then compile the project. The second mix compile is required due to Mix only invoking the same task once in an alias. defp aliases do [ sentry_recompile : [ &quot;compile&quot; , &quot;deps.compile sentry --force&quot; ] ] end This is an important to note especially when building for production. If your build or deployment system caches prior builds, it may not recompile Sentry and could cause issues with reported source code being out of date. Due to Sentry reading the file system and defaulting to a recursive search of directories, it is important to check your configuration and compilation environment to avoid a folder recursion issue. Problems may be seen when deploying to the root folder, so it is best to follow the practice of compiling your application in its own folder. Modifying the :source_code_path_pattern configuration option from its default is also an avenue to avoid compile problems.","ref":"Sentry.html","title":"Sentry","type":"module"},{"doc":"Parses and submits an exception to Sentry This only sends the exception if the current Sentry environment is in the :included_environments . See the Configuration section in the module documentation. The opts argument is passed as the second argument to send_event/2 .","ref":"Sentry.html#capture_exception/2","title":"Sentry.capture_exception/2","type":"function"},{"doc":"Reports a message to Sentry. opts argument is passed as the second argument to Sentry.send_event/2 .","ref":"Sentry.html#capture_message/2","title":"Sentry.capture_message/2","type":"function"},{"doc":"Gets the last event ID sent to the server from the process dictionary. Since it uses the process dictionary, it will only return the last event ID sent within the current process.","ref":"Sentry.html#get_last_event_id_and_source/0","title":"Sentry.get_last_event_id_and_source/0","type":"function"},{"doc":"Puts the last event ID sent to the server for the current process in the process dictionary.","ref":"Sentry.html#put_last_event_id_and_source/2","title":"Sentry.put_last_event_id_and_source/2","type":"function"},{"doc":"Sends an event to Sentry. An event is the most generic payload you can send to Sentry. It encapsulates information about an exception, a message, or any other event that you want to report. To manually build events, see the functions in Sentry.Event . Options The supported options are: :result - Allows specifying how the result should be returned. The possible values are: :sync - Sentry will make an API call synchronously (including retries) and will return {:ok, event_id} if successful. :none - Sentry will send the event in the background, in a fire-and-forget fashion. The function will return {:ok, &quot;&quot;} regardless of whether the API call ends up being successful or not. :async - Not supported anymore , see the information below. :sample_rate - The sampling factor to apply to events. A value of 0.0 will deny sending any events, and a value of 1.0 will send 100% of events. Sampling is applied after the :before_send_event callback. See where the Sentry documentation suggests this. Other options, such as :stacktrace or :extra , will be passed to Sentry.Event.create_event/1 downstream. See Sentry.Event.create_event/1 for available options. Async Send Before v9.0.0 of this library, the :result option also supported the :async value. This would spawn a Task to make the API call, and would return a {:ok, Task.t()} tuple. You could use Task operations to wait for the result asynchronously. Since v9.0.0, this option is not present anymore. Instead, you can spawn a task yourself that then calls this function with result: :sync . The effect is exactly the same. Sending Exceptions and Messages This function is low-level , and mostly intended for library developers, or folks that want to have full control on what they report to Sentry. For most use cases, use capture_exception/2 or capture_message/2 .","ref":"Sentry.html#send_event/2","title":"Sentry.send_event/2","type":"function"},{"doc":"A callback to use with the :after_send_event configuration option. If this is {module, function_name} , then module.function_name(event, result) will be called, where event is of type Sentry.Event.t/0 .","ref":"Sentry.html#t:after_send_event_callback/0","title":"Sentry.after_send_event_callback/0","type":"type"},{"doc":"A callback to use with the :before_send_event configuration option. configuration options.k If this is {module, function_name} , then module.function_name(event) will be called, where event is of type Sentry.Event.t/0 . See the Configuration section in the module documentation for more information on configuration.","ref":"Sentry.html#t:before_send_event_callback/0","title":"Sentry.before_send_event_callback/0","type":"type"},{"doc":"","ref":"Sentry.html#t:send_result/0","title":"Sentry.send_result/0","type":"type"},{"doc":"The strategy to use when sending an event to Sentry.","ref":"Sentry.html#t:send_type/0","title":"Sentry.send_type/0","type":"type"},{"doc":"Provides functionality to store user, tags, extra, and breadcrumbs context when an event is reported. The contexts will be fetched and merged into the event when it is sent. Sentry.Context uses Elixir Logger metadata to store the context itself. This imposes some limitations. The metadata will only exist within the current process , and the context will disappear when the process dies. For example, if you add context inside your controller and an error happens in a spawned Task , that context will not be included. A common use case is to set context when handling requests within Plug or Phoenix applications, as each request is its own process, and so any stored context is included should an error be reported within that request process. For example: # post_controller.ex def index ( conn , _params ) do Sentry.Context . set_user_context ( %{ id : conn . assigns . user_id } ) posts = Blog . list_posts ( ) render ( conn , &quot;index.html&quot; , posts : posts ) end Merging The set_*_context/1 functions merge with the existing context rather than entirely overwriting it. Sentry Documentation Sentry itself documents the meaning of the various contexts: General context interface Breadcrumbs interface Request context User context","ref":"Sentry.Context.html","title":"Sentry.Context","type":"module"},{"doc":"Adds a new breadcrumb to the :breadcrumb context, specific to the current process. Breadcrumbs are used to record a series of events that led to a specific instance of an error. Breadcrumbs can contain arbitrary key data to assist in understanding what happened before an error occurred. See the Sentry documentation for more information. If breadcrumb_info is a keyword list, it should be convertable to a map of type breadcrumb/0 . Example iex&gt; Sentry.Context . add_breadcrumb ( message : &quot;first_event&quot; ) :ok iex&gt; Sentry.Context . add_breadcrumb ( %{ message : &quot;second_event&quot; , type : &quot;auth&quot; } ) %{ breadcrumbs : [ %{ :message =&gt; &quot;first_event&quot; , &quot;timestamp&quot; =&gt; 1562007480 } ] } iex&gt; Sentry.Context . add_breadcrumb ( %{ message : &quot;response&quot; } ) %{ breadcrumbs : [ %{ :message =&gt; &quot;second_event&quot; , :type =&gt; &quot;auth&quot; , &quot;timestamp&quot; =&gt; 1562007505 } , %{ :message =&gt; &quot;first_event&quot; , &quot;timestamp&quot; =&gt; 1562007480 } ] } iex&gt; Sentry.Context . get_all ( ) %{ breadcrumbs : [ %{ :message =&gt; &quot;first_event&quot; , &quot;timestamp&quot; =&gt; 1562007480 } , %{ :message =&gt; &quot;second_event&quot; , :type =&gt; &quot;auth&quot; , &quot;timestamp&quot; =&gt; 1562007505 } , %{ :message =&gt; &quot;response&quot; , &quot;timestamp&quot; =&gt; 1562007517 } ] , extra : %{ } , request : %{ } , tags : %{ } , user : %{ } }","ref":"Sentry.Context.html#add_breadcrumb/1","title":"Sentry.Context.add_breadcrumb/1","type":"function"},{"doc":"Clears all existing context for the current process. Example iex&gt; Sentry.Context . set_tags_context ( %{ id : 123 } ) :ok iex&gt; Sentry.Context . clear_all ( ) :ok iex&gt; Sentry.Context . get_all ( ) %{ breadcrumbs : [ ] , extra : %{ } , request : %{ } , tags : %{ } , user : %{ } }","ref":"Sentry.Context.html#clear_all/0","title":"Sentry.Context.clear_all/0","type":"function"},{"doc":"Returns the keys used to store context in the current process' logger metadata. Example iex&gt; Sentry.Context . context_keys ( ) [ :breadcrumbs , :tags , :user , :extra , :request ]","ref":"Sentry.Context.html#context_keys/0","title":"Sentry.Context.context_keys/0","type":"function"},{"doc":"Retrieves all currently-set context on the current process. Example iex&gt; Sentry.Context . set_user_context ( %{ id : 123 } ) iex&gt; Sentry.Context . set_tags_context ( %{ message_id : 456 } ) iex&gt; Sentry.Context . get_all ( ) %{ user : %{ id : 123 } , tags : %{ message_id : 456 } , extra : %{ } , request : %{ } , breadcrumbs : [ ] }","ref":"Sentry.Context.html#get_all/0","title":"Sentry.Context.get_all/0","type":"function"},{"doc":"Merges new fields into the :extra context, specific to the current process. This is used to set fields which should display when looking at a specific instance of an error. Example iex&gt; Sentry.Context . set_extra_context ( %{ id : 123 } ) :ok iex&gt; Sentry.Context . set_extra_context ( %{ detail : &quot;bad_error&quot; } ) :ok iex&gt; Sentry.Context . set_extra_context ( %{ message : &quot;Oh no&quot; } ) :ok iex&gt; Sentry.Context . get_all ( ) %{ user : %{ } , tags : %{ } , extra : %{ detail : &quot;bad_error&quot; , id : 123 , message : &quot;Oh no&quot; } , request : %{ } , breadcrumbs : [ ] }","ref":"Sentry.Context.html#set_extra_context/1","title":"Sentry.Context.set_extra_context/1","type":"function"},{"doc":"Merges new fields into the :request context, specific to the current process. This is used to set metadata that identifies the request associated with a specific instance of an error. The request context is documented in the Sentry documentation . Invalid Keys While this function accepts any map with atom keys, the only keys that are valid are those in t:Sentry.Interfaces.request/0 . We don't validate keys because of performance concerns, so it's up to you to ensure that you're passing valid keys. Example iex&gt; Sentry.Context . set_request_context ( %{ url : &quot;example.com&quot; } ) :ok iex&gt; headers = %{ &quot;accept&quot; =&gt; &quot;application/json&quot; } iex&gt; Sentry.Context . set_request_context ( %{ headers : headers , method : &quot;GET&quot; } ) :ok iex&gt; Sentry.Context . get_all ( ) %{ breadcrumbs : [ ] , extra : %{ } , request : %{ method : &quot;GET&quot; , headers : %{ &quot;accept&quot; =&gt; &quot;application/json&quot; } , url : &quot;example.com&quot; } , tags : %{ } , user : %{ } }","ref":"Sentry.Context.html#set_request_context/1","title":"Sentry.Context.set_request_context/1","type":"function"},{"doc":"Merges new fields into the :tags context, specific to the current process. This is used to set fields which should display when looking at a specific instance of an error. These fields can also be used to search and filter on. Example iex&gt; Sentry.Context . set_tags_context ( %{ id : 123 } ) :ok iex&gt; Sentry.Context . set_tags_context ( %{ other_id : 456 } ) :ok iex&gt; Sentry.Context . get_all ( ) %{ breadcrumbs : [ ] , extra : %{ } , request : %{ } , tags : %{ id : 123 , other_id : 456 } , user : %{ } }","ref":"Sentry.Context.html#set_tags_context/1","title":"Sentry.Context.set_tags_context/1","type":"function"},{"doc":"Merges new fields into the :user context, specific to the current process. This is used to set certain fields which identify the actor who experienced a specific instance of an error. The user context is documented in the Sentry documentation . Additional Keys While at least one of the keys described in Sentry.Interfaces.user/0 is recommended, you can also add any arbitrary key to the user context. Example iex&gt; Sentry.Context . set_user_context ( %{ id : 123 } ) :ok iex&gt; Sentry.Context . set_user_context ( %{ username : &quot;george&quot; } ) :ok iex&gt; Sentry.Context . get_all ( ) %{ user : %{ id : 123 , username : &quot;george&quot; } , tags : %{ } , extra : %{ } , request : %{ } , breadcrumbs : [ ] }","ref":"Sentry.Context.html#set_user_context/1","title":"Sentry.Context.set_user_context/1","type":"function"},{"doc":"Breadcrumb info. See add_breadcrumb/1 . All the atom keys in this map can also be specified as strings. Example %{ type : &quot;default&quot; , category : &quot;ui.click&quot; , data : nil , level : &quot;info&quot; , message : &quot;User clicked on the main button&quot; , timestamp : 1596814007.035 }","ref":"Sentry.Context.html#t:breadcrumb/0","title":"Sentry.Context.breadcrumb/0","type":"type"},{"doc":"A map of extra data. See set_extra_context/1 .","ref":"Sentry.Context.html#t:extra/0","title":"Sentry.Context.extra/0","type":"type"},{"doc":"Request context. See set_request_context/1 . This map gets eventually converted into a Sentry.Interfaces.Request struct.","ref":"Sentry.Context.html#t:request_context/0","title":"Sentry.Context.request_context/0","type":"type"},{"doc":"A map of tags . See set_tags_context/1 .","ref":"Sentry.Context.html#t:tags/0","title":"Sentry.Context.tags/0","type":"type"},{"doc":"User context. See set_user_context/1 . You can use &quot;{{auto}}&quot; as the value of :ip_address to let Sentry infer the IP address (see the documentation for automatic IP addresses ). Other than the keys specified in the typespec below, all other keys are stored as extra information but not specifically processed by Sentry. Example %{ user : %{ id : &quot;unique_id&quot; , username : &quot;my_user&quot; , email : &quot;foo@example.com&quot; , ip_address : &quot;127.0.0.1&quot; , # Extra key subscription : &quot;basic&quot; } }","ref":"Sentry.Context.html#t:user_context/0","title":"Sentry.Context.user_context/0","type":"type"},{"doc":"The default implementation of the Sentry.EventFilter behaviour. This filter excludes the following exceptions: Phoenix.NotAcceptableError Phoenix.Router.NoRouteError Plug.Conn.InvalidQueryError Plug.Parsers.BadEncodingError Plug.Parsers.ParseError Plug.Parsers.RequestTooLarge Plug.Parsers.UnsupportedMediaTypeError Plug.Static.InvalidPathError In addition, it excludes routes that do not match in plug routers.","ref":"Sentry.DefaultEventFilter.html","title":"Sentry.DefaultEventFilter","type":"module"},{"doc":"Provides functions to create Sentry events from scratch, from exceptions, and so on. This module also contains the main event struct. Events are the fundamental data that clients send to the Sentry server. See https://develop.sentry.dev/sdk/event-payloads .","ref":"Sentry.Event.html","title":"Sentry.Event","type":"module"},{"doc":"The struct representing the event. You're not advised to manipulate this struct's fields directly. Instead, use functions such as create_event/1 or transform_exception/2 for creating events. See the t/0 type for information on the fields and their types.","ref":"Sentry.Event.html#__struct__/0","title":"Sentry.Event.__struct__/0","type":"function"},{"doc":"Creates an event struct out of collected context and options. Merging Options with Context and Config Some of the options documented below are merged with the Sentry context, or with the Sentry context and the configuration. The option you pass here always has higher precedence, followed by the context and finally by the configuration. See also Sentry.Context for information on the Sentry context and Sentry for information on configuration. Options :exception - an Exception.t/0 . This is the exception that gets reported in the :exception field of t/0 . The term passed here also ends up unchanged in the :original_exception field of t/0 . This option is required unless the :message option is present. This is not present by default. :stacktrace - a stacktrace, as in Exception.stacktrace/0 . This is not present by default. :message - a message ( String.t/0 ). This is not present by default. :extra - map of extra context, which gets merged with the current context (see Sentry.Context.set_extra_context/1 ). If fields collide, the ones in the map passed through this option have precedence over the ones in the context. Defaults to %{} . :user - map of user context, which gets merged with the current context (see Sentry.Context.set_user_context/1 ). If fields collide, the ones in the map passed through this option have precedence over the ones in the context. Defaults to %{} . :tags - map of tags context, which gets merged with the current context (see Sentry.Context.set_tags_context/1 ) and with the :tags option in the global Sentry configuration. If fields collide, the ones in the map passed through this option have precedence over the ones in the context, which have precedence over the ones in the configuration. Defaults to %{} . :request - map of request context, which gets merged with the current context (see Sentry.Context.set_request_context/1 ). If fields collide, the ones in the map passed through this option have precedence over the ones in the context. Defaults to %{} . :breadcrumbs - list of breadcrumbs. This list gets prepended to the list in the context (see Sentry.Context.add_breadcrumb/1 ). Defaults to [] . :level - error level (see t/0 ). Defaults to :error . :fingerprint - list of the fingerprint for grouping this event (a list of String.t/0 ). Defaults to [&quot;{{ default }}&quot;] . :event_source - the source of the event. This fills in the :source field of the returned struct. This is not present by default. Examples iex&gt; event = create_event ( exception : % RuntimeError { message : &quot;oops&quot; } , level : :warning ) iex&gt; event . level :warning iex&gt; hd ( event . exception ) . type &quot;RuntimeError&quot; iex&gt; event . original_exception % RuntimeError { message : &quot;oops&quot; } iex&gt; event = create_event ( message : &quot;Unknown route&quot; , event_source : :plug ) iex&gt; event . source :plug","ref":"Sentry.Event.html#create_event/1","title":"Sentry.Event.create_event/1","type":"function"},{"doc":"Transforms an exception to a Sentry event. This essentially defers to create_event/1 , inferring some options from the given exception . Options This function takes the same options as create_event/1 .","ref":"Sentry.Event.html#transform_exception/2","title":"Sentry.Event.transform_exception/2","type":"function"},{"doc":"The level of an event.","ref":"Sentry.Event.html#t:level/0","title":"Sentry.Event.level/0","type":"type"},{"doc":"The type for the event struct. All of the fields in this struct map directly to the fields described in the Sentry documentation . These fields are the exceptions, and are specific to the Elixir Sentry SDK: :source - the source of the event. Sentry.LoggerBackend and Sentry.LoggerHandler set this to :logger , while Sentry.PlugCapture and Sentry.PlugContext set it to :plug . You can set it to any atom. See the :event_source option in create_event/1 and transform_exception/2 . :original_exception - the original exception that is being reported, if there's one. The Elixir Sentry SDK manipulates reported exceptions to make them fit the payload required by the Sentry API, and these end up in the :exception field. The :original_exception field, instead, contains the original exception as the raw Elixir term (such as %RuntimeError{...} ). See also %Sentry.Event{} .","ref":"Sentry.Event.html#t:t/0","title":"Sentry.Event.t/0","type":"type"},{"doc":"A behaviour for filtering events to send to Sentry. There's only one callback to implement, exclude_exception?/2 . Soft-deprecated This behaviour is soft-deprecated in favor of filtering events through the :before_send_event callback functionality. :before_send_event is described in details in the documentation for the Sentry module. It's a more general mechanism to filter or modify events before sending them to Sentry. See below for an example of how to replace an event filter with a :before_send_event callback. In future major versions of this library, we might hard-deprecate or remove this behaviour altogether. Usage To use a custom event filter module, configure the :filter option in the :sentry application. For example: config :sentry , filter : MyApp.SentryEventFilter The default event filter is Sentry.DefaultEventFilter . Examples As an example, if you wanted to exclude all ArithmeticError exceptions and nothing else: defmodule MyApp.SentryEventFilter do @behaviour Sentry.EventFilter @impl true def exclude_exception? ( % ArithmeticError { } , _source ) , do : true def exclude_exception? ( _exception , _source ) , do : false end Alternatively, if you wanted to skip all non-500 exceptions in a Plug app: defmodule MyApp.SentryEventFilter do @behaviour Sentry.EventFilter @impl true def exclude_exception? ( exception , _source ) do Plug.Exception . status ( exception ) &lt; 500 end end If you want to exclude some specific exceptions but then fall back to the default event filter, you can do something like this: defmodule MyApp.SentryEventFilter do @behaviour Sentry.EventFilter @impl true def exclude_exception? ( % ArithmeticError { } , _source ) do true end def exclude_exception? ( exception , source ) do Sentry.DefaultEventFilter . exclude_exception? ( exception , source ) end end Replacing With :before_send_event Let's look at an example of how to filter non-500 exceptions in a Plug app through the :before_send_event callback. We can start with a module: defmodule MyApp.SentryEventFilter do def filter_non_500 ( % Sentry.Event { __original_exception__ : exception } = event ) do cond do if Plug.Exception . status ( exception ) &lt; 500 -&gt; false # Fall back to the default event filter. Sentry.DefaultEventFilter . exclude_exception? ( exception , event . __source__ ) -&gt; false true -&gt; event end end end Then, we can configure the :before_send_event callback. config :sentry , before_send_event : { MyApp.SentryEventFilter , :filter_non_500 } Multiple Callbacks You can only have one :before_send_event callback. If you change the value of this configuration option, you'll override the previous callback. If you want to do multiple things in a :before_send_event callback, create a function that does all the things you need and register that as the callback.","ref":"Sentry.EventFilter.html","title":"Sentry.EventFilter","type":"behaviour"},{"doc":"Should return whether the given event should be excluded from being reported to Sentry. exception is the exception that was raised. source is the source of the event. Events from Sentry.PlugCapture will have :plug as a source and events from Sentry.LoggerBackend will have :logger as the source. A custom source can also be specified by passing the :event_source option to Sentry.capture_exception/2 .","ref":"Sentry.EventFilter.html#c:exclude_exception?/2","title":"Sentry.EventFilter.exclude_exception?/2","type":"callback"},{"doc":"A behaviour for HTTP clients that Sentry can use. The default HTTP client is Sentry.HackneyClient . To configure a different HTTP client, implement the Sentry.HTTPClient behaviour and change the :client configuration: config :sentry , client : MyHTTPClient Child Spec The child_spec/0 callback is a callback that should be used when you want Sentry to start the HTTP client under its supervision tree . If you want to start your own HTTP client under your application's supervision tree, just don't implement the callback and Sentry won't do anything to start the client. Optional Since v9.0.0 The child_spec/0 callback is optional only since v9.0.0 of Sentry, and was required before. Alternative Clients Let's look at an example of using an alternative HTTP client. In this example, we'll use Finch , a lightweight HTTP client for Elixir. First, we need to add Finch to our dependencies: # In mix.exs defp deps do [ # ... { :finch , &quot;~&gt; 0.16&quot; } ] end Then, we need to define a module that implements the Sentry.HTTPClient behaviour: defmodule MyApp.SentryFinchHTTPClient do @behaviour Sentry.HTTPClient @impl true def child_spec do Supervisor . child_spec ( { Finch , name : __MODULE__ } , id : __MODULE__ ) end @impl true def post ( url , headers , body ) do request = Finch . build ( :post , url , headers , body ) case Finch . request ( request , __MODULE__ ) do { :ok , % Finch.Response { status : status , headers : headers , body : body } } -&gt; { :ok , status , headers , body } { :error , error } -&gt; { :error , error } end end end Last, we need to configure Sentry to use our new HTTP client: config :sentry , client : MyApp.SentryFinchHTTPClient","ref":"Sentry.HTTPClient.html","title":"Sentry.HTTPClient","type":"behaviour"},{"doc":"Should return a child specification to start the HTTP client. For example, this can start a pool of HTTP connections dedicated to Sentry. If not provided, Sentry won't do anything to start your HTTP client. See the module documentation for more info.","ref":"Sentry.HTTPClient.html#c:child_spec/0","title":"Sentry.HTTPClient.child_spec/0","type":"callback"},{"doc":"Should make an HTTP POST request to url with the given headers and body .","ref":"Sentry.HTTPClient.html#c:post/3","title":"Sentry.HTTPClient.post/3","type":"callback"},{"doc":"HTTP request or response body.","ref":"Sentry.HTTPClient.html#t:body/0","title":"Sentry.HTTPClient.body/0","type":"type"},{"doc":"HTTP request or response headers.","ref":"Sentry.HTTPClient.html#t:headers/0","title":"Sentry.HTTPClient.headers/0","type":"type"},{"doc":"The response status for an HTTP request.","ref":"Sentry.HTTPClient.html#t:status/0","title":"Sentry.HTTPClient.status/0","type":"type"},{"doc":"The built-in HTTP client. This client implements the Sentry.HTTPClient behaviour. It's based on the hackney Erlang HTTP client, which is an optional dependency of this library. If you wish to use another HTTP client, you'll have to implement your own Sentry.HTTPClient . See the documentation for Sentry.HTTPClient for more information. Sentry starts its own hackney pool called :sentry_pool . If you need to set other hackney configuration options for things such as proxies, using your own pool, or response timeouts, the :hackney_opts configuration is passed directly to hackney for each request. See the configuration documentation in the Sentry module.","ref":"Sentry.HackneyClient.html","title":"Sentry.HackneyClient","type":"module"},{"doc":"Provides basic functionality to capture and send errors occurring within Plug applications, including Phoenix. It is intended for usage with Sentry.PlugContext , which adds relevant request metadata to the Sentry context before errors are captured. Usage With Phoenix In a Phoenix application, it is important to use this module before the Phoenix endpoint itself. It should be added to your endpoint.ex file: defmodule MyApp.Endpoint use Sentry.PlugCapture use Phoenix.Endpoint , otp_app : :my_app # ... end With Plug In a Plug application, you can add this module below your router: defmodule MyApp.PlugRouter do use Plug.Router use Sentry.PlugCapture # ... end use Sentry.PlugCapture When you use Sentry.PlugCapture , Sentry overrides your Plug.call/2 callback and adds capturing errors and reporting to Sentry. You can still re-override that callback after use Sentry.PlugCapture if you need to. Scrubbing Sensitive Data Since v9.1.0 Scrubbing sensitive data in Sentry.PlugCapture is available since v9.1.0 of this library. Like Sentry.PlugContext , this module also supports scrubbing sensitive data out of errors. However, this module has to do some guessing to figure out if there are Plug.Conn structs to scrub. Right now, the strategy we use follows these steps: if the error is Phoenix.ActionClauseError , we scrub the Plug.Conn structs from the args field of that exception Otherwise, we don't perform any scrubbing. To configure scrubbing, you can use the :scrubbing option (see below). Options :scrubber (since v9.1.0) - a term of type {module, function, args} that will be invoked to scrub sensitive data from Plug.Conn structs. The Plug.Conn struct is prepended to args before invoking the function, so that the final function will be called as apply(module, function, [conn | args]) . The function must return a Plug.Conn struct. By default, the built-in scrubber does this: scrubs all cookies scrubs sensitive headers just like Sentry.PlugContext.default_header_scrubber/1 scrubs sensitive body params just like Sentry.PlugContext.default_body_scrubber/1","ref":"Sentry.PlugCapture.html","title":"Sentry.PlugCapture","type":"module"},{"doc":"A Plug for adding request context to Sentry events. This module adds Sentry context metadata during the request in a Plug application. It includes defaults for scrubbing sensitive data, and options for customizing such behavior. Usage You can use this module in a Plug pipeline to add Sentry metadata: plug Sentry.PlugContext However, this module is generally intended to be used with Sentry.PlugCapture : this plug will add context metadata to the request, while Sentry.PlugCapture will capture raised exceptions and errors and report them to Sentry with the added metadata. Scrubbing POST Body Params In order to send POST body parameters you should first scrub them of sensitive information. By default, they will be scrubbed with default_body_scrubber/1 . This can be overridden by passing the :body_scrubber option, which accepts a Plug.Conn and returns a map to send. Setting :body_scrubber to nil will not send any data back. If you would like to make use of Sentry's default scrubber behavior in a custom scrubber, it can be called directly. An example configuration may look like the following: defmodule MySentryScrubber do def scrub_params ( conn ) do # Makes use of the default body_scrubber to avoid sending password # and credit card information in plain text. To also prevent sending # our sensitive &quot;my_secret_field&quot; and &quot;other_sensitive_data&quot; fields, # we simply drop those keys. conn |&gt; Sentry.PlugContext . default_body_scrubber ( ) |&gt; Map . drop ( [ &quot;my_secret_field&quot; , &quot;other_sensitive_data&quot; ] ) end end Then pass it into Sentry.PlugContext : plug Sentry.PlugContext , body_scrubber : &amp; MySentryScrubber . scrub_params / 1 You can also pass it in as a {module, fun} , like so: plug Sentry.PlugContext , body_scrubber : { MyModule , :scrub_params } Large Files If you are sending large files in POST requests, we recommend you scrub them out through the :body_scrubber mechanism. Scrubbing Headers By default, Sentry uses default_header_scrubber/1 to scrub headers. This can be configured similarly to body params, through the :header_scrubber configuration option: defmodule MyHeaderScrubber do def scrub_headers ( conn ) do # In this example, we do not want to include Content-Type or User-Agent # in reported headers, so we drop them. conn . req_headers |&gt; Map . new ( ) |&gt; Sentry.PlugContext . default_header_scrubber ( ) |&gt; Map . drop ( [ &quot;content-type&quot; , &quot;user-agent&quot; ] ) end end Then, pass it into Sentry.PlugContext : plug Sentry.PlugContext , header_scrubber : &amp; MyHeaderScrubber . scrub_headers / 1 It can also be passed in as a {module, fun} like so: plug Sentry.PlugContext , header_scrubber : { MyModule , :scrub_headers } Scrubbing Cookies By default Sentry will scrub all cookies before sending events (see scrub_cookies/1 ). It can be configured similarly to the headers and body scrubbers, but is configured via the :cookie_scrubber key. For example: plug Sentry.PlugContext , cookie_scrubber : &amp; MyCookieScrubber . scrub_cookies / 1 Including Request Identifiers If you're using Phoenix, Plug.RequestId , or any other method to set a request ID response header, and would like to include that information with errors reported by Sentry.PlugContext , use the :request_id_header option. It allows you to set which header key Sentry should check. It defaults to x-request-id , which Plug.RequestId (and therefore Phoenix) also default to. plug Sentry.PlugContext , request_id_header : &quot;application-request-id&quot; Remote Address Reader Sentry.PlugContext includes a request's originating IP address under the REMOTE_ADDR environment key in Sentry. By default, we read it from the x-forwarded-for HTTP header, and if this header is not present, from conn.remote_ip . If you wish to read this value differently (for example, from a different HTTP header), or modify it in some other way (such as by masking it), you can configure this behavior by passing the :remote_address_reader option: plug Sentry.PlugContext , remote_address_reader : &amp; MyModule . read_ip / 1 The :remote_address_reader option must be a function that accepts a Plug.Conn returns a String.t/0 IP, or a {module, function} tuple, where module.function/1 takes a Plug.Conn and returns a String.t/0 IP.","ref":"Sentry.PlugContext.html","title":"Sentry.PlugContext","type":"module"},{"doc":"Scrubs the body of a request. The default scrubbed keys are: password passwd secret","ref":"Sentry.PlugContext.html#default_body_scrubber/1","title":"Sentry.PlugContext.default_body_scrubber/1","type":"function"},{"doc":"Scrubs all cookies off of the request.","ref":"Sentry.PlugContext.html#default_cookie_scrubber/1","title":"Sentry.PlugContext.default_cookie_scrubber/1","type":"function"},{"doc":"Scrubs the headers of a request. The default scrubbed headers are: authorization authentication cookie","ref":"Sentry.PlugContext.html#default_header_scrubber/1","title":"Sentry.PlugContext.default_header_scrubber/1","type":"function"},{"doc":"Report Logger events like crashed processes to Sentry. To include in your application, start this backend in your application start/2 callback: # lib/my_app/application.ex def start ( _type , _args ) do Logger . add_backend ( Sentry.LoggerBackend ) Sentry context will be included in metadata in reported events. Example: Sentry.Context . set_user_context ( %{ user_id : current_user . id } ) :logger handler In new projects, try to use Sentry.LoggerHandler rather than this Logger backend. Elixir will likely deprecate Logger backends in the future in favor of :logger handlers, which would lead to us eventually removing this backend. Configuration :excluded_domains - Any messages with a domain in the configured list will not be sent. Defaults to [:cowboy] to avoid double reporting events from Sentry.PlugCapture . :metadata - To include non-Sentry Logger metadata in reports, the :metadata key can be set to a list of keys. Metadata under those keys will be added in the :extra context under the :logger_metadata key. Defaults to [] . If set to :all , all metadata will be included. :all is available since v9.0.0 of this library. :level - The minimum [Logger level]( https://hexdocs.pm/logger/Logger.html#module-levels to send events for. Defaults to :error . :capture_log_messages - When true , this module will send all Logger messages. Defaults to false , which will only send messages with metadata that has the shape of an exception and stacktrace. Example: config :logger , Sentry.LoggerBackend , # Also send warning messages level : :warning , # Send messages from Plug/Cowboy excluded_domains : [ ] , # Include metadata added with `Logger.metadata([foo_bar: &quot;value&quot;])` metadata : [ :foo_bar ] , # Send messages like `Logger.error(&quot;error&quot;)` to Sentry capture_log_messages : true","ref":"Sentry.LoggerBackend.html","title":"Sentry.LoggerBackend","type":"module"},{"doc":":logger handler to report logged events to Sentry. This module is similar to Sentry.LoggerBackend , but it implements a :logger handler rather than an Elixir's Logger backend. This module is available since v9.0.0 of this library . When to Use the Handler vs the Backend? There is no functional difference in behavior between Sentry.LoggerHandler and Sentry.LoggerBackend when it comes to reporting to Sentry. The main functional difference is that Sentry.LoggerBackend runs in its own process, while Sentry.LoggerHandler runs in the process that logs. The latter is generally preferable. The reason both exist is that :logger handlers are a relatively-new feature in Erlang/OTP, and Sentry.LoggerBackend was created before :logger handlers were introduced. In general, try to use Sentry.LoggerHandler if possible. In future Elixir releases, Logger backends may become deprecated and hence Sentry.LoggerBackend may be eventually removed. Crash Reports The reason you'll want to add this handler to your application is so that you can report crashes in your system to Sentry. Sometimes, you're able to catch exceptions and handle them (such as reporting them to Sentry), which is what you can do with Sentry.PlugCapture for example. However, Erlang/OTP systems are made of processes running concurrently, and sometimes those processes crash and exit . If you're not explicitly catching exceptions in those processes to report them to Sentry, then you won't see those crash reports in Sentry. That's where this handler comes in. This handler hooks into :logger and reports nicely-formatted crash reports to Sentry. Usage To add this handler to your system, see the documentation for handlers in Elixir . You can configure this handler in the :logger key under your application's configuration, potentially alongside other :logger handlers: config :my_app , :logger , [ { :handler , :my_sentry_handler , Sentry.LoggerHandler , %{ config : %{ metadata : [ :file , :line ] } } } ] If you do this, then you'll want to add this to your application's Application.start/2 callback, similarly to what you would do with Sentry.LoggerBackend and the call to Logger.add_backend/1 : def start ( _type , _args ) do Logger . add_handlers ( :my_app ) # ... end Alternatively, you can skip the :logger configuration and add the handler directly to your application's Application.start/2 callback: def start ( _type , _args ) do :logger . add_handler ( :my_sentry_handler , Sentry.LoggerHandler , %{ config : %{ metadata : [ :file , :line ] } } ) # ... end Configuration This handler supports the following configuration options: :excluded_domains (list of atom/0 ) - any messages with a domain in the configured list will not be sent. Defaults to [:cowboy] to avoid double-reporting events from Sentry.PlugCapture . :metadata (list of atom/0 , or :all ) - use this to include non-Sentry logger metadata in reports. If it's a list of keys, metadata in those keys will be added in the :extra context (see Sentry.Context.set_extra_context/1 ) under the :logger_metadata key. If set to :all , all metadata will be included. Defaults to [] . :level ( Logger.level/0 ) - the minimum Logger level to send events for. Defaults to :error . :capture_log_messages ( boolean/0 ) - when true , this module will report all logged messages to Sentry (provided they're not filtered by :excluded_domains and :level ). Defaults to false , which will only send crash reports , which are messages with metadata that has the shape of an exit reason and a stacktrace.","ref":"Sentry.LoggerHandler.html","title":"Sentry.LoggerHandler","type":"module"},{"doc":"Top-level module for Sentry interfaces. Interfaces are pieces of the event payload that include various kinds of information. See the event payloads documentation and its subsections. The types in this module and the nested structs are taken from Sentry's JSONSchema definitions .","ref":"Sentry.Interfaces.html","title":"Sentry.Interfaces","type":"module"},{"doc":"The generic context interface. See https://develop.sentry.dev/sdk/event-payloads/contexts .","ref":"Sentry.Interfaces.html#t:context/0","title":"Sentry.Interfaces.context/0","type":"type"},{"doc":"The user interface. This interface is not a struct since it allows any additional arbitrary key other than the ones defined in the schema. See https://develop.sentry.dev/sdk/event-payloads/user .","ref":"Sentry.Interfaces.html#t:user/0","title":"Sentry.Interfaces.user/0","type":"type"},{"doc":"The struct for a single breadcrumb interface. See https://develop.sentry.dev/sdk/event-payloads/breadcrumbs .","ref":"Sentry.Interfaces.Breadcrumb.html","title":"Sentry.Interfaces.Breadcrumb","type":"module"},{"doc":"","ref":"Sentry.Interfaces.Breadcrumb.html#t:t/0","title":"Sentry.Interfaces.Breadcrumb.t/0","type":"type"},{"doc":"The struct for the exception interface. See https://develop.sentry.dev/sdk/event-payloads/exception .","ref":"Sentry.Interfaces.Exception.html","title":"Sentry.Interfaces.Exception","type":"module"},{"doc":"","ref":"Sentry.Interfaces.Exception.html#t:t/0","title":"Sentry.Interfaces.Exception.t/0","type":"type"},{"doc":"The struct for the request interface. See https://develop.sentry.dev/sdk/event-payloads/request .","ref":"Sentry.Interfaces.Request.html","title":"Sentry.Interfaces.Request","type":"module"},{"doc":"","ref":"Sentry.Interfaces.Request.html#t:t/0","title":"Sentry.Interfaces.Request.t/0","type":"type"},{"doc":"The struct for the SDK interface. This is usually filled in by the SDK itself. See https://develop.sentry.dev/sdk/event-payloads/sdk .","ref":"Sentry.Interfaces.SDK.html","title":"Sentry.Interfaces.SDK","type":"module"},{"doc":"","ref":"Sentry.Interfaces.SDK.html#t:t/0","title":"Sentry.Interfaces.SDK.t/0","type":"type"},{"doc":"The struct for the stacktrace interface. See https://develop.sentry.dev/sdk/event-payloads/stacktrace .","ref":"Sentry.Interfaces.Stacktrace.html","title":"Sentry.Interfaces.Stacktrace","type":"module"},{"doc":"","ref":"Sentry.Interfaces.Stacktrace.html#t:t/0","title":"Sentry.Interfaces.Stacktrace.t/0","type":"type"},{"doc":"The struct for the stacktrace frame to be used within exceptions. See Sentry.Interfaces.Stacktrace .","ref":"Sentry.Interfaces.Stacktrace.Frame.html","title":"Sentry.Interfaces.Stacktrace.Frame","type":"module"},{"doc":"","ref":"Sentry.Interfaces.Stacktrace.Frame.html#t:t/0","title":"Sentry.Interfaces.Stacktrace.Frame.t/0","type":"type"},{"doc":"Bad software is everywhere, and we're tired of it. Sentry is on a mission to help developers write better software faster, so we can get back to enjoying technology. If you want to join us &lt;kbd&gt; Check out our open positions &lt;/kbd&gt; This is the official Sentry SDK for [Sentry]. 💁: This README documents unreleased features (from the master branch). For documentation on the current release, see [the official documentation][docs].","ref":"readme.html","title":"README","type":"extras"},{"doc":"Install To use Sentry in your project, add it as a dependency in your mix.exs file. Sentry does not install a JSON library nor HTTP client by itself. Sentry will default to trying to use [Jason] for JSON serialization and [Hackney] for HTTP requests, but can be configured to use other ones. To use the default ones, do: defp deps do [ # ... { :sentry , &quot;~&gt; 9.0&quot; } , { :jason , &quot;~&gt; 1.4&quot; } , { :hackney , &quot;~&gt; 1.19&quot; } ] end Configuration Sentry has a range of configuration options, but most applications will have a configuration that looks like the following: # config/config.exs config :sentry , dsn : &quot;https://public_key@app.getsentry.com/1&quot; , environment_name : Mix . env ( ) , included_environments : [ :prod ] , enable_source_code_context : true , root_source_code_paths : [ File . cwd! ( ) ] Usage This library comes with a [ :logger handler][logger-handlers] to capture error messages coming from process crashes. To enable this, add the handler when your application starts: def start(_type, _args) do + :logger.add_handler(:sentry_handler, Sentry.LoggerHandler, %{}) # ... end The handler can also be configured to capture Logger metadata. See the documentation here . Sometimes you want to capture specific exceptions manually. To do so, use Sentry.capture_exception/2 . try do ThisWillError . really ( ) rescue my_exception -&gt; Sentry . capture_exception ( my_exception , stacktrace : __STACKTRACE__ ) end Sometimes you want to capture messages that are not exceptions. To do that, use Sentry.capture_message/2 : Sentry . capture_message ( &quot;custom_event_name&quot; , extra : %{ extra : information } ) To learn more about how to use this SDK, refer to [the documentation][docs].","ref":"readme.html#getting-started","title":"README - Getting Started","type":"extras"},{"doc":"[Phoenix and Plug][setup-phoenix-and-plug]","ref":"readme.html#integrations","title":"README - Integrations","type":"extras"},{"doc":"Please refer to `CONTRIBUTING.md`` . ## Getting Help/Support If you need help setting up or configuring the Python SDK (or anything else in the Sentry universe) please head over to the Sentry Community on Discord . There is a ton of great people in our Discord community ready to help you! ## Resources [ ][docs] * ## License Licensed under the MIT license, see LICENSE . ### Context and Breadcrumbs Sentry has multiple options for including contextual information. They are organized into &quot;Tags&quot;, &quot;User&quot;, and &quot;Extra&quot;, and Sentry's documentation on them is here . Breadcrumbs are a similar concept and Sentry's documentation covers them here . In Elixir this can be complicated due to processes being isolated from one another. Tags context can be set globally through configuration, and all contexts can be set within a process, and on individual events. If an event is sent within a process that has some context configured it will include that context in the event. Examples of each are below, and for more information see the documentation of Sentry.Context . elixir # Global Tags context via configuration: config :sentry, tags: %{my_app_version: &quot;14.30.10&quot;} # ... # Process-based Context Sentry.Context.set_extra_context(%{day_of_week: &quot;Friday&quot;}) Sentry.Context.set_user_context(%{id: 24, username: &quot;user_username&quot;, has_subscription: true}) Sentry.Context.set_tags_context(%{locale: &quot;en-us&quot;}) Sentry.Context.add_breadcrumb(%{category: &quot;web.request&quot;}) # Event-based Context Sentry.capture_exception(exception, [tags: %{locale: &quot;en-us&quot;, }, user: %{id: 34}, extra: %{day_of_week: &quot;Friday&quot;}, breadcrumbs: [%{timestamp: 1461185753845, category: &quot;web.request&quot;}]] ### Fingerprinting By default, Sentry aggregates reported events according to the attributes of the event, but users may need to override this functionality via fingerprinting . To achieve that in Sentry Elixir, one can use the before_send_event configuration callback. If there are certain types of errors you would like to have grouped differently, they can be matched on in the callback, and have the fingerprint attribute changed before the event is sent. An example configuration and implementation could look like: elixir # lib/sentry.ex defmodule MyApp.Sentry def before_send(%{exception: [%{type: DBConnection.ConnectionError}]} = event) do %{event | fingerprint: [&quot;ecto&quot;, &quot;db_connection&quot;, &quot;timeout&quot;]} end def before_send(event) do event end end # config.exs config :sentry, before_send_event: {MyApp.Sentry, :before_send}, # ... ### Reporting Exceptions with Source Code Sentry's server supports showing the source code that caused an error, but depending on deployment, the source code for an application is not guaranteed to be available while it is running. To work around this, the Sentry library reads and stores the source code at compile time. This has some unfortunate implications. If a file is changed, and Sentry is not recompiled, it will still report old source code. The best way to ensure source code is up to date is to recompile Sentry itself via mix deps.compile sentry --force . It's possible to create a Mix Task alias in mix.exs to do this. The example below allows one to run mix sentry_recompile &amp;&amp; mix compile which will compile any uncompiled or changed parts of the application, and then force recompilation of Sentry so it has the newest source. The second mix compile is required due to Mix only invoking the same task once in an alias. elixir # mix.exs defp aliases do [sentry_recompile: [&quot;compile&quot;, &quot;deps.compile sentry --force&quot;]] end For more documentation, see Sentry.Sources . ## Testing Your Configuration To ensure you've set up your configuration correctly we recommend running the included mix task. It can be tested on different Mix environments and will tell you if it is not currently configured to send events in that environment: bash $ MIX_ENV=dev mix sentry.send_test_event Client configuration: server: https://sentry.io/ public_key: public secret_key: secret included_environments: [:prod] current environment_name: :dev :dev is not in [:prod] so no test event will be sent $ MIX_ENV=prod mix sentry.send_test_event Client configuration: server: https://sentry.io/ public_key: public secret_key: secret included_environments: [:prod] current environment_name: :prod Sending test event! ## Testing with Sentry In some cases, users may want to test that certain actions in their application cause a report to be sent to Sentry. Sentry itself does this by using Bypass . It is important to note that when modifying the environment configuration the test case should not be run asynchronously. Not returning the environment configuration to its original state could also affect other tests depending on how the Sentry configuration interacts with them. Example: elixir test &quot;add/2 does not raise but sends an event to Sentry when given bad input&quot; do bypass = Bypass.open() Bypass.expect(bypass, fn conn -&gt; {:ok, _body, conn} = Plug.Conn.read_body(conn) Plug.Conn.resp(conn, 200, ~s&lt;{&quot;id&quot;: &quot;340&quot;}&gt;) end) Application.put_env(:sentry, :dsn, &quot;http://public:secret@localhost:\#{bypass.port}/1&quot;) Application.put_env(:sentry, :send_result, :sync) MyModule.add(1, &quot;a&quot;) end When testing, you will also want to set the send_result type to :sync , so the request is done synchronously. [Sentry]: http://sentry.io/ [Jason]: https://github.com/michalmuskala/jason [Hackney]: https://github.com/benoitc/hackney [docs]: https://hexdocs.pm/sentry/readme.html [logger-handlers]: https://www.erlang.org/doc/apps/kernel/logger_chapter#handlers [setup-phoenix-and-plug]: https://hexdocs.pm/sentry/setup-with-plug-and-phoenix.html","ref":"readme.html#contributing-to-the-sdk","title":"README - Contributing to the SDK","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Various fixes &amp; improvements Attempt to scrub all Plug.Conn s in Sentry.PlugCapture (#619) by @whatyouhide Fix typespec for the Sentry.Context.t/0 type (#618) by @whatyouhide Apply :sample_rate after event callbacks, rather than before (ab5c7485) by @whatyouhide","ref":"changelog.html#9-1-0","title":"Changelog - 9.1.0","type":"extras"},{"doc":"Breaking changes Removed Sentry.Sources Removed Sentry.Client , as it's an internal module Removed the Sentry.Event.sentry_exception/0 type Removed Sentry.Event.add_metadata/1 Removed Sentry.Event.culprit_from_stacktrace/1 Removed Sentry.Event.do_put_source_context/3 Removed the :async value for the :result option in Sentry.send_event/2 (and friends) Removed Sentry.CrashError — now, crash reports (detected through Sentry.LoggerBackend ) that do not contain exceptions are reported as messages in Sentry Changed the shape of the Sentry.Event struct - check out the new fields (and typespec for Sentry.Event.t/0 ) Various fixes &amp; improvements Add Sentry.LoggerHandler , which is a :logger handler rather than a Logger backend Make the Sentry.HTTPClient.child_spec/0 callback optional Add :all as a possible value of the :metadata configuration option for Sentry.LoggerBackend Add :all as a possible value for the :included_environment configuration option Add Sentry.Interfaces with all the child modules, which are useful if you're working directly with the Sentry API Fix an issue with JSON-encoding non-encodable terms (such as PIDs, which are pretty common) Deprecations Soft-deprecate Sentry.EventFilter in favour of :before_send_event callbacks. Various fixes &amp; improvements Remove manually-entered entries from the CHANGELOG (48cf37d9) by @whatyouhide Don't cover test/support in tests (8cfe14b1) by @whatyouhide Make two more funs private in Sentry.Event (340ba143) by @whatyouhide Add excoveralls for code coverage (58d94cf2) by @whatyouhide Clean up Sentry.Config (f996c7d3) by @whatyouhide Revert default :included_environments to [:prod] (d33bf19d) by @whatyouhide Send async events right away without queueing (#612) by @whatyouhide Make Sentry.Interfaces.Request a struct (#611) by @whatyouhide Improve some tests (59e8ebb0) by @whatyouhide Add Sentry logo to the docs (6d27eacf) by @whatyouhide Polish docs for &quot;mix sentry.send_test_event&quot; (903aeb93) by @whatyouhide Update changelog and error messages (f6f577f4) by @whatyouhide Soft-deprecate Sentry.EventFilter (#608) by @whatyouhide Improve Sentry.Event struct definition (#609) by @whatyouhide Clean up docs and tests for &quot;mix sentry.send_test_event&quot; (#610) by @whatyouhide Add Sentry.LoggerHandler (#607) by @whatyouhide Remove Sentry.CrashError and improve EXIT reporting (#606) by @whatyouhide Support :all in Sentry.LoggerBackend's :metadata (#605) by @whatyouhide Optimize JSON sanitization step (b96d6cfd) by @whatyouhide Accept all environments by default (#604) by @whatyouhide Add example about alternative HTTP client to docs (38e80edf) by @whatyouhide Make Sentry.HTTPClient.child_spec/0 optional (#603) by @whatyouhide Clean up a bunch of little non-important things (18e83ae9) by @whatyouhide Simplify test GenServer (30a9828e) by @whatyouhide","ref":"changelog.html#9-0-0","title":"Changelog - 9.0.0","type":"extras"},{"doc":"Various fixes &amp; improvements Bump min craft version to 1.4.2 (795bfd12) by @sl0thentr0py Add github target to craft (ef563cc5) by @sl0thentr0py Bump min craft version (56516be2) by @sl0thentr0py Improve deprecation of Sentry.Config.root_source_code_path/0 (#558) by @whatyouhide Wrap HTTP requests in try/catch (#515) by @ruslandoga Remove extra config files (#556) by @yordis Remove use of deprecated Mix.Config (#555) by @whatyouhide Add release/** branches to ci for craft (dfaffb9f) by @sl0thentr0py Fix typo in moduledoc (#534) by @louisvisser Check :hackney application when starting (#554) by @whatyouhide feat(event): filter more exceptions by default (#550) by @gpouilloux Fix example configuration for Sentry.Sources (#543) by @scudelletti Use module attribute for dictionary key consistently (#537) by @tmecklem Fix send_event/2 typespec (#545) by @ruslandoga Update badges in the README (#548) by @ruslandoga Update ex_docs to 0.29+ (#549) by @ruslandoga Fix Elixir 1.15 warnings (#553) by @dustinfarris Add :remote_address_reader PlugContext option (#519) by @michallepicki Traverse full domain list when checking for excluded domains (#508) by @martosaur Add craft with target hex (#532) by @sl0thentr0py Add Sentry to LICENSE (#530) by @sl0thentr0py Update ci setup-beam action name (#531) by @sl0thentr0py allow logging from tasks (#517) by @ruslandoga Improve DSN parsing and Endpoint building (#507) by @AtjonTV Plus 14 more","ref":"changelog.html#8-1-0","title":"Changelog - 8.1.0","type":"extras"},{"doc":"Bug Fixes Remove function that disables non-group leader logging (#467) Handle :unsampled events in Sentry.send_test_event (#474) Fix dialyzer reporting unmatched_return for Sentry.PlugCapture (#475) Use correct Plug.Parsers exception module (#482)","ref":"changelog.html#8-0-6-2021-09-28","title":"Changelog - 8.0.6 (2021-09-28)","type":"extras"},{"doc":"Enhancements Support lists in scrubbing (#442) Send Sentry reports on uncaught throws/exits (#447) Bug Fixes Deprecate Sentry.Config.in_app_module_whitelist in favor of Sentry.Config.in_app_module_allow_list (#450) Update outdated Sentry.Plug documentation (#452) Update Sentry.HTTPClient documentation (#456)","ref":"changelog.html#8-0-5-2021-02-14","title":"Changelog - 8.0.5 (2021-02-14)","type":"extras"},{"doc":"Bug Fixes Do not read DSN config at compile time (#441)","ref":"changelog.html#8-0-4-2020-11-16","title":"Changelog - 8.0.4 (2020-11-16)","type":"extras"},{"doc":"Enhancements Update package &amp; docs configuration (#432) Add Plug.Status filter example (#433) Support multiple source code root paths in Sentry.Sources (#437) Bug Fixes Fix dialyzer reporting unmatched_return for Sentry.PlugCapture (#436) Align Sentry event levels with Elixir logging levels (#439)","ref":"changelog.html#8-0-3-2020-11-11","title":"Changelog - 8.0.3 (2020-11-11)","type":"extras"},{"doc":"Enhancements Log error when JSON is unencodable (#429) Set logger event level to logger message level (#430) Limit breadcrumbs on add_breadcrumb (#431)","ref":"changelog.html#8-0-2-2020-09-06","title":"Changelog - 8.0.2 (2020-09-06)","type":"extras"},{"doc":"Enhancements Add plug parsing errors to list of default excluded params (#414) Make Sentry.PlugContext.scrub_map public (#417) Allow users to configure maximum number of breadcrumbs (#418)","ref":"changelog.html#8-0-1-2020-08-08","title":"Changelog - 8.0.1 (2020-08-08)","type":"extras"},{"doc":"7.x -&gt; 8.0 Upgrade Guide Bug Fixes Fix documentation for Sentry.PlugContext (#410)","ref":"changelog.html#8-0-0-2020-07-13","title":"Changelog - 8.0.0 (2020-07-13)","type":"extras"},{"doc":"Bug Fixes Fix trying to transform erlang error coming from PlugCapture (#406)","ref":"changelog.html#8-0-0-rc-2-2020-07-01","title":"Changelog - 8.0.0-rc.2 (2020-07-01)","type":"extras"},{"doc":"Bug Fixes Remove changes that were unintentionally included in build","ref":"changelog.html#8-0-0-rc-1-2020-06-29","title":"Changelog - 8.0.0-rc.1 (2020-06-29)","type":"extras"},{"doc":"Enhancements Cache environment config in application config (#393) Allow configuring LoggerBackend to send all messages, not just exceptions (e.g. Logger.error(&quot;I am an error message&quot;) ) Bug Fixes fix request url port in payloads for HTTPS requests (#391) Breaking Changes Change default included_environments to only include :prod by default (#370) Change default event send type to :none instead of :async (#341) Make hackney an optional dependency, and simplify Sentry.HTTPClient behaviour (#400) Use Logger.metadata for Sentry.Context, no longer return metadata values on set_* functions, and rename set_http_context to set_request_context (#401) Move excluded exceptions from Sentry.Plug to Sentry.DefaultEventFilter (#402) Remove Sentry.Plug and Sentry.Phoenix.Endpoint in favor of Sentry.PlugContext and Sentry.PlugCapture (#402) Remove feedback form rendering and configuration (#402) Logger metadata is now specified by key in LoggerBackend instead of enabled/disabled (#403) Require Elixir 1.10 and optionally plug_cowboy 2.3 (#403) Sentry.capture_exception/1 now only accepts exceptions (#403)","ref":"changelog.html#8-0-0-rc-0-2020-06-24","title":"Changelog - 8.0.0-rc.0 (2020-06-24)","type":"extras"},{"doc":"Enhancements Allow configuring gather feedback form for Sentry.Plug errors (#387)","ref":"changelog.html#7-2-4-2020-03-09","title":"Changelog - 7.2.4 (2020-03-09)","type":"extras"},{"doc":"Enhancements Allow gathering feedback from Sentry.Plug errors (#385)","ref":"changelog.html#7-2-3-2020-02-27","title":"Changelog - 7.2.3 (2020-02-27)","type":"extras"},{"doc":"Bug Fixes Ensure stacktrace is list in LoggerBackend (#380)","ref":"changelog.html#7-2-2-2020-02-13","title":"Changelog - 7.2.2 (2020-02-13)","type":"extras"},{"doc":"Bug Fixes Improve documentation for Sentry.Client.send_event/2 (#367) Fix potential Logger deadlock (#372) Pass the same exception for NoRouteError in Sentry.Phoenix.Endpoint (#376) Handle new MFA for duplicate Plug errors (#377) Update docs to recommend using application environment config for adding Sentry.LoggerBackend (#379)","ref":"changelog.html#7-2-1-2019-12-05","title":"Changelog - 7.2.1 (2019-12-05)","type":"extras"},{"doc":"Enhancements Allow filtering of Events using before_send_event (#364) Bug Fixes Remove newline from Logger for API error (#351) Add docs for Sentry.Context (#352) Avoid error duplication for Plug errors (#355) Fix issue in Sentry.Sources docs around recompilation (#357)","ref":"changelog.html#7-2-0-2019-10-23","title":"Changelog - 7.2.0 (2019-10-23)","type":"extras"},{"doc":"Enhancements Option to include Logger.metadata in Sentry.LoggerBackend (#338) Send maximum length of args in stacktrace (#340) Fix dialyzer warning when using Sentry.Phoenix.Endpoint (#344) Bug Fixes Fix documentation error relating to File.cwd!() (#346) Add parens to File.cwd!() in documentation (#347) Check that DSN is binary (#348)","ref":"changelog.html#7-1-0-2019-06-11","title":"Changelog - 7.1.0 (2019-06-11)","type":"extras"},{"doc":"Enhancements Allow configuring Sentry log level (#334)","ref":"changelog.html#7-0-6-2019-04-17","title":"Changelog - 7.0.6 (2019-04-17)","type":"extras"},{"doc":"Bug Fixes Strip leading &quot;Elixir.&quot; from module name on error type (#330)","ref":"changelog.html#7-0-5-2019-04-05","title":"Changelog - 7.0.5 (2019-04-05)","type":"extras"},{"doc":"Bug Fixes Do not error if you cannot format the remote IP or port (#326)","ref":"changelog.html#7-0-4-2019-02-12","title":"Changelog - 7.0.4 (2019-02-12)","type":"extras"},{"doc":"Bug Fixes Fix issue from using spawn_link stacktrace (#315) Relax plug_cowboy versions (#314)","ref":"changelog.html#7-0-3-2018-11-14","title":"Changelog - 7.0.3 (2018-11-14)","type":"extras"},{"doc":"Bug Fixes Fix sending Phoenix.Router.NoRouteError when using Sentry.Phoenix.Endpoint (#309)","ref":"changelog.html#7-0-2-2018-11-01","title":"Changelog - 7.0.2 (2018-11-01)","type":"extras"},{"doc":"Enhancements Remove Poison from applications list (#306)","ref":"changelog.html#7-0-1-2018-10-01","title":"Changelog - 7.0.1 (2018-10-01)","type":"extras"},{"doc":"Enhancements Implement Sentry.LoggerBackend Breaking Changes Replace Poison with configurable JSON library Require Elixir 1.7+ Remove Sentry.Logger","ref":"changelog.html#7-0-0-2018-09-07","title":"Changelog - 7.0.0 (2018-09-07)","type":"extras"},{"doc":"Enhancements Add deps reporting back (#305 / #301)","ref":"changelog.html#6-4-2-2018-09-05","title":"Changelog - 6.4.2 (2018-09-05)","type":"extras"},{"doc":"Bug Fixes Remove UUID dependency (#298) Fix link in documentation (#300)","ref":"changelog.html#6-4-1-2018-07-26","title":"Changelog - 6.4.1 (2018-07-26)","type":"extras"},{"doc":"Enhancements Add documentation detail around including source code (#287) Document fingerprinting (#288) Document Sentry.Context (#289) Add CONTRIBUTING.md (#290) Document cookie scrubber (#291) Document testing with Sentry (#292) Bug Fixes Change report_deps default value to false to avoid compiler bug (#285) Limit size of messages (#293) Use elixir_uuid instead of uuid (#295)","ref":"changelog.html#6-4-0-2018-07-02","title":"Changelog - 6.4.0 (2018-07-02)","type":"extras"},{"doc":"Enhancements Use the stacktrace passed to Sentry.Event.transform_exception/2 when calling Exception.normalize/3 (#266) Reduce Logger noise in HTTP Client (#274) Use Plug.Conn.get_peer_data/1 (#273) Bug Fixes Add documentation for capturing arbitrary events (#272) Fix typo in README.md (#277)","ref":"changelog.html#6-3-0-2018-06-26","title":"Changelog - 6.3.0 (2018-06-26)","type":"extras"},{"doc":"Enhancements Accept public key DSNs (#263)","ref":"changelog.html#6-2-1-2018-04-24","title":"Changelog - 6.2.1 (2018-04-24)","type":"extras"},{"doc":"Enhancements Allow overriding in Sentry.Plug (#261) Implement Sentry.Phoenix.Endpoint to capture errors in Phoenix.Endpoint (#259) Bug Fixes Fix sending events from remote_console (#262) Add filter option to configuration table in README (#255) Default to not sending cookies, but allow configuration to send (#254) Do not raise on invalid DSN (#218)","ref":"changelog.html#6-2-0-2018-04-04","title":"Changelog - 6.2.0 (2018-04-04)","type":"extras"},{"doc":"Enhancements Elixir 1.6.0 formatted (#246) Improve documentation around source code compilation (#242) Update typespecs (#249) Report errors from :kernel.spawn processes (#251) Bug Fixes Fix doc typos (#245) Remove Sentry.Event compile warning (#248) Fix enable_source_code_context configuration (#247)","ref":"changelog.html#6-1-0-2017-12-07","title":"Changelog - 6.1.0 (2017-12-07)","type":"extras"},{"doc":"Enhancements Improve README documentation (#236) Fix GenEvent warning (#237, #239) Bug Fixes Fix error_type reported in Sentry.Plug (#238)","ref":"changelog.html#6-0-5-2017-12-07","title":"Changelog - 6.0.5 (2017-12-07)","type":"extras"},{"doc":"Enhancements Allow string for included_environments by splitting on commas (#234) Bug Fixes Handle :error when sending test event (#228)","ref":"changelog.html#6-0-4-2017-11-20","title":"Changelog - 6.0.4 (2017-11-20)","type":"extras"},{"doc":"Enhancements Fix tests for differing versions of Erlang/Elixir (#221) Bug Fixes Fix invalid value for stacktrace via Event rendering layer (#224)","ref":"changelog.html#6-0-3-2017-11-01","title":"Changelog - 6.0.3 (2017-11-01)","type":"extras"},{"doc":"Enhancements Improve Sentry.Logger documentation (#217) Bug Fixes Handle Plug.Upload during scrubbing (#208) Do not check DSN for source_code_path_pattern configuration (#211) Fix culprit ambiguity (#214)","ref":"changelog.html#6-0-2-2017-10-03","title":"Changelog - 6.0.2 (2017-10-03)","type":"extras"},{"doc":"Bug Fixes Fix filters and test mix task (#206) Enhancements Improve README clarity (#202)","ref":"changelog.html#6-0-1-2017-09-06","title":"Changelog - 6.0.1 (2017-09-06)","type":"extras"},{"doc":"See these 5.0.0 to 6.0.0 upgrade instructions to update your existing app. Breaking Changes Remove use_error_logger configuration (#196) enable_source_code_context is no longer required configuration (#201) Bug Fixes Fix README error (#197) Prevent overwriting server_name option (#200) Enhancements Scrubbing of nested maps (#192) Allow Hackney 1.9 and later (#199)","ref":"changelog.html#6-0-0-2017-08-29","title":"Changelog - 6.0.0 (2017-08-29)","type":"extras"},{"doc":"Bug Fixes Fix logger and context usage (#185)","ref":"changelog.html#5-0-1-2017-07-18","title":"Changelog - 5.0.1 (2017-07-18)","type":"extras"},{"doc":"Backward incompatible changes Allow specifying sync/async/none when getting result of sending event (#174) Enhancements Modules (#182) Config from system and DSN (#180) App Frames (#177) Sampling (#176) Post event hook (#175) Improve documentation around recompilation for source code context (#171) Use better arity logic in stacktraces (#170) Allow custom fingerprinting (#160) Bug Fixes Fix README typo (#159) Fix the backoff to really be exponential (#162)","ref":"changelog.html#5-0-0-2017-07-10","title":"Changelog - 5.0.0 (2017-07-10)","type":"extras"},{"doc":"Enhancements Update and improve Travis build matrix (#155) Specify behaviour for Sentry HTTP clients (#158)","ref":"changelog.html#4-0-3-2017-05-17","title":"Changelog - 4.0.3 (2017-05-17)","type":"extras"},{"doc":"Enhancements Relax hackney requirements","ref":"changelog.html#4-0-2-2017-04-26","title":"Changelog - 4.0.2 (2017-04-26)","type":"extras"},{"doc":"Enhancements Bump hackney to a version that fixes major bug (#153)","ref":"changelog.html#4-0-1-2017-04-25","title":"Changelog - 4.0.1 (2017-04-25)","type":"extras"},{"doc":"See these 3.0.0 to 4.0.0 upgrade instructions to update your existing app. Enhancements Bump hackney to a version that isn't retired (#135) Improve Logger reporting (#136) Accept keyword lists in Sentry.Context.add_breadcrumb/1 (#139) Add elements to beginning of breadcrumbs list for performance (#141) Close unread hackney responses properly (#149) Improve Sentry.Client code style (#147) Fix invalid specs in Sentry methods (#146) Allow setting client at runtime (#150) Backward incompatible changes Return :ignored instead of {:ok, &quot;&quot;} when event is not sent because environment_name is not in included_environments in Sentry.send_event , Sentry.capture_exception , or Sentry.capture_message (#146) Return :ignored and log warning instead of returning {:ok, &quot;Sentry: unable to parse exception&quot;} when unable to parse exception in Sentry.send_event , Sentry.capture_exception , or Sentry.capture_message (#146) Return {:ok, Task} instead of Task when an event is successfully sent with Sentry.send_event , Sentry.capture_exception , or Sentry.capture_message (#146) Ignore non-existent route exceptions (#110) Sending source code as context when reporting errors (#138)","ref":"changelog.html#4-0-0-2017-04-20","title":"Changelog - 4.0.0 (2017-04-20)","type":"extras"},{"doc":"Enhancements Add dialyzer support (#128) Backward incompatible changes Fix default configuration (#124) Start and use separate Sentry hackney pool instead of default (#130) Return :error instead of raising when encoding invalid JSON (#131)","ref":"changelog.html#3-0-0-2017-03-02","title":"Changelog - 3.0.0 (2017-03-02)","type":"extras"},{"doc":"Enhancements Allow setting hackney_opts Add Sentry.capture_message/1 Allow reading :dsn from System at runtime by configuring as {:system, &quot;ENV_VAR&quot;}","ref":"changelog.html#2-2-0-2017-02-15","title":"Changelog - 2.2.0 (2017-02-15)","type":"extras"},{"doc":"Enhancements Allow filtering which exceptions are sent via Sentry.EventFilter behaviour Add Sentry.Context.set_http_context/1 Bug Fixes Fix usage of deprecated modules Fix README documentation Fix timestamp parameter format","ref":"changelog.html#2-1-0-2016-12-17","title":"Changelog - 2.1.0 (2016-12-17)","type":"extras"},{"doc":"Bug Fixes Fix regex checking of non-binary values","ref":"changelog.html#2-0-2-2016-12-08","title":"Changelog - 2.0.2 (2016-12-08)","type":"extras"},{"doc":"Bug Fixes Fix compilation error when Plug is not available","ref":"changelog.html#2-0-1-2016-12-05","title":"Changelog - 2.0.1 (2016-12-05)","type":"extras"},{"doc":"Enhancements Return a task when sending a Sentry event Provide default scrubber for request body and headers ( Sentry.Plug.default_body_scrubber and Sentry.Plug.default_header_scrubber ) Header scrubbing can now be configured with :header_scrubber Bug Fixes Ensure mix sentry.send_test_event finishes sending event before ending Mix task Backward incompatible changes Sentry.capture_exception/1 now returns a Task instead of {:ok, PID} Sentry.Plug :scrubber option has been removed in favor of the more descriptive :body_scrubber option, which defaults to newly added Sentry.Plug.default_scrubber/1 New option for Sentry.Plug :header_scrubber defaults to newly added Sentry.Plug.default_header_scrubber/1 Request bodies were not previously sent by default. Because of above change, request bodies are now sent by default after being scrubbed by default scrubber. To prevent sending any data, :body_scrubber should be set to nil","ref":"changelog.html#2-0-0-2016-11-28","title":"Changelog - 2.0.0 (2016-11-28)","type":"extras"},{"doc":"You can capture errors in Plug (and Phoenix) applications with Sentry.PlugContext and Sentry.PlugCapture . Sentry.PlugContext adds contextual metadata from the current request which is then included in errors that are captured and reported by Sentry.PlugCapture .","ref":"setup-with-plug-and-phoenix.html","title":"Setup with Plug and Phoenix","type":"extras"},{"doc":"If you are using Phoenix: Add Sentry.PlugCapture above the use Phoenix.Endpoint line in your endpoint file Add Sentry.PlugContext below Plug.Parsers defmodule MyAppWeb.Endpoint + use Sentry.PlugCapture use Phoenix.Endpoint, otp_app: :my_app # ... plug Plug.Parsers, parsers: [:urlencoded, :multipart, :json], pass: [&quot;*/*&quot;], json_decoder: Phoenix.json_library() + plug Sentry.PlugContext Capturing User Feedback If you would like to capture user feedback as described here , the Sentry.get_last_event_id_and_source/0 function can be used to see if Sentry has sent an event within the current Plug process (and get the source of that event). :plug will be the source for events coming from Sentry.PlugCapture . The options described in the Sentry documentation linked above can be encoded into the response as well. An example Phoenix application setup that displays the user feedback form on 500 responses on requests accepting HTML could look like this: defmodule MyAppWeb.ErrorView do # ... def render ( &quot;500.html&quot; , _assigns ) do case Sentry . get_last_event_id_and_source ( ) do { event_id , :plug } when is_binary ( event_id ) -&gt; opts = Jason . encode! ( %{ eventId : event_id } ) ~E&quot;&quot;&quot; &lt;script src=&quot;https://browser.sentry-cdn.com/5.9.1/bundle.min.js&quot; integrity=&quot;sha384-/x1aHz0nKRd6zVUazsV6CbQvjJvr6zQL2CHbQZf3yoLkezyEtZUpqUNnOLW9Nt3v&quot; crossorigin=&quot;anonymous&quot;&gt;&lt;/script&gt; &lt;script&gt; Sentry.init({ dsn: &#39;&lt;%= Sentry.Config.dsn() %&gt;&#39; }); Sentry.showReportDialog(&lt;%= raw opts %&gt;) &lt;/script&gt; &quot;&quot;&quot; _ -&gt; &quot;Error&quot; end end end","ref":"setup-with-plug-and-phoenix.html#for-phoenix-applications","title":"Setup with Plug and Phoenix - For Phoenix Applications","type":"extras"},{"doc":"If you are in a non-Phoenix Plug application: Add Sentry.PlugCapture at the top of your Plug application Add Sentry.PlugContext below Plug.Parsers (if it is in your stack) defmodule MyApp.Router do use Plug.Router + use Sentry.PlugCapture # ... plug Plug.Parsers, parsers: [:urlencoded, :multipart] + plug Sentry.PlugContext","ref":"setup-with-plug-and-phoenix.html#for-plug-applications","title":"Setup with Plug and Phoenix - For Plug Applications","type":"extras"},{"doc":"Sentry 8.x requires Elixir 1.10 and Sentry 7.x will be maintained for applications running prior versions. Documentation for Sentry 7.x can be found here . If you would like to upgrade a project to use Sentry 8.x, see here .","ref":"upgrade-8-x.html","title":"Upgrade to Sentry 8.x","type":"extras"},{"doc":"This guide contains information on how to upgrade from Sentry 8.x to Sentry 9.x. If you're on a version lower than 8.x, see the previous upgrade guides to get to 8.x before going through this one.","ref":"upgrade-9-x.html","title":"Upgrade to Sentry 9.x","type":"extras"},{"doc":"Sentry 9.0.0 requires Elixir 1.11+. If you're still running on Elixir 1.10 or lower, use Sentry 8.x or lower.","ref":"upgrade-9-x.html#check-your-elixir-version","title":"Upgrade to Sentry 9.x - Check Your Elixir Version","type":"extras"},{"doc":"Before 9.0.0, the Sentry Elixir library supported one way of passing configuration through query parameters in the configured Sentry DSN. This is not supported anymore in 9.0.0. To upgrade: Remove query parameters from your configured Sentry DSN. Set the values for those parameters as normal configuration, either via the application environment, or via environment variables. For example: # In config/config.exs # Replace this: config :sentry , dsn : &quot;https://public:secret@app.getsentry.com/1?server_name=my-server&quot; # with this: config :sentry , dsn : &quot;https://public:secret@app.getsentry.com/1&quot; , server_name : &quot;my-server&quot;","ref":"upgrade-9-x.html#remove-dsn-query-params","title":"Upgrade to Sentry 9.x - Remove DSN Query Params","type":"extras"},{"doc":"Sentry now requires the :environment_name configuration to be set, since the default was causing potential issues (such as #524 ). To fix this, configure :environment_name or set the SENTRY_ENVIRONMENT system environment variable.","ref":"upgrade-9-x.html#make-sure-the-environment-name-is-configured","title":"Upgrade to Sentry 9.x - Make Sure the Environment Name Is Configured","type":"extras"},{"doc":"Sentry 9.0.0 stops using many &quot;magic&quot; system environment variables for configuration. These were environment variables prefixed with SENTRY_ . If you were using these environment variables, you'll either need to configure the corresponding setting through the application environment, or you'll need to read those variables yourself (at runtime ). For example, if you were setting SENTRY_LOG_LEVEL , you'll have to do something like: # In config/runtime.exs config :sentry , log_level : System . fetch_env! ( &quot;SENTRY_LOG_LEVEL&quot; ) We strongly recommend you do this in config/runtime.exs so that you'll read the system environment when starting your application. This is going to work both for local development as well as in Mix releases . This is the new system environment variables configuration: System environment variable Corresponding configuration setting Supported in 9.0.0+ SENTRY_SERVER_NAME :server_name ❌ SENTRY_LOG_LEVEL :log_level ❌ SENTRY_CONTEXT_LINES :context_lines ❌ SENTRY_ENVIRONMENT_NAME :environment_name ❌ — use SENTRY_ENVIRONMENT SENTRY_ENVIRONMENT :environment_name ✅ SENTRY_DSN :dsn ✅ SENTRY_RELEASE :release ✅","ref":"upgrade-9-x.html#fix-your-environment-variables","title":"Upgrade to Sentry 9.x - Fix Your Environment Variables","type":"extras"},{"doc":"Sentry used to support setting configuration options to {:system, var} in order to read var from the system environment at runtime. This behavior was there to compensate for releases before Mix releases were introduced. With Mix releases, you can use config/runtime.exs to have runtime configuration that works both within releases and using Mix (like during local development). To fix this, remove all the {:system, var} values from the Sentry configuration, move those options to config/runtime.exs , and use normal System functions to read the environment (such as System.fetch_env!/1 ). # Before, in config/config.exs ❌ config :sentry , # ..., environment_name : { :system , &quot;SENTRY_ENV&quot; } # Now, in config/runtime.exs ✅ config :sentry , # ..., environment_name : System . fetch_env! ( &quot;SENTRY_ENV&quot; )","ref":"upgrade-9-x.html#stop-using-system-var","title":"Upgrade to Sentry 9.x - Stop Using {:system, var}","type":"extras"},{"doc":"Some configuration settings that Sentry supports are needed to compile Sentry itself. Before 9.0.0, you could change the value of these settings (such as :enable_source_code_context ) at runtime, but it would have no effect. It would only do something if you were to change the value at compile time, and then you'd recompile Sentry itself. Elixir v1.10.0 introduced Application.compile_env/2 however. This means that we were able to turn those settings into explicit compile-time settings . If you change the value of any of these settings now and forget to recompile Sentry, Mix will yell at you. The fix for this is simple: do what Mix says. The settings that are now compile-time settings are: :enable_source_code_context :root_source_code_paths :report_deps :source_code_path_pattern :source_code_exclude_patterns","ref":"upgrade-9-x.html#fix-compile-time-configuration","title":"Upgrade to Sentry 9.x - Fix Compile-Time Configuration","type":"extras"},{"doc":"Sentry.Sources was meant to be private API and has been removed. Its functionality is very specific to Sentry, and it's not a good general mechanism to retrieve source code. This way, we can also have the freedom to improve this functionality without making potential breaking changes to the API of this library.","ref":"upgrade-9-x.html#stop-using-sentry-sources","title":"Upgrade to Sentry 9.x - Stop Using Sentry.Sources","type":"extras"},{"doc":"Most of the functionality that you could find in Sentry.Client was also available in the Sentry module. Additionally, most of the functions within Sentry.Client were not really usable in a generic way without deep knowledge of this library and the Sentry ecosystem.","ref":"upgrade-9-x.html#stop-using-sentry-client","title":"Upgrade to Sentry 9.x - Stop Using Sentry.Client","type":"extras"},{"doc":"We removed the :async possible value from the :result option of Sentry.Client.send_event/2 . Instead, you can spawn a task yourself. If you had something like this before: { :ok , sentry_task } = Sentry . capture_exception ( my_exception , result : :async ) # Do other stuff... Task . await ( sentry_task ) you can now replace it with something like: # Start a supervisor for this somewhere, maybe in your application&#39;s # start/2 callback. { :ok , _ } = Task.Supervisor . start_link ( name : SentryAsyncSupervisor ) { :ok , sentry_task } = Task.Supervisor . async_nolink ( fn -&gt; Sentry . capture_exception ( my_exception , result : :async ) end ) # Do other stuff... Task . await ( sentry_task )","ref":"upgrade-9-x.html#stop-using-result-async","title":"Upgrade to Sentry 9.x - Stop Using result: :async","type":"extras"}]